'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.toggleAware = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _hoistNonReactStatics = require('hoist-non-react-statics');

var _hoistNonReactStatics2 = _interopRequireDefault(_hoistNonReactStatics);

var _reactDisplayName = require('react-display-name');

var _reactDisplayName2 = _interopRequireDefault(_reactDisplayName);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var toggleAware = exports.toggleAware = function toggleAware() {
    var _ref = arguments.length <= 0 || arguments[0] === undefined ? {} : arguments[0];

    var _ref$onDelay = _ref.onDelay;
    var onDelay = _ref$onDelay === undefined ? 0 : _ref$onDelay;
    var _ref$offDelay = _ref.offDelay;
    var offDelay = _ref$offDelay === undefined ? 0 : _ref$offDelay;
    var _ref$handler = _ref.handler;
    var handler = _ref$handler === undefined ? 'onToggle' : _ref$handler;
    var _ref$key = _ref.key;
    var key = _ref$key === undefined ? 'isToggled' : _ref$key;
    return function (OriginalComponent) {
        // create higher order component to track state

        var WrappedComponent = function (_Component) {
            _inherits(WrappedComponent, _Component);

            function WrappedComponent() {
                _classCallCheck(this, WrappedComponent);

                var _this = _possibleConstructorReturn(this, Object.getPrototypeOf(WrappedComponent).call(this));

                _this.onToggle = function () {
                    var _this$props;

                    if (_this.props[handler]) (_this$props = _this.props)[handler].apply(_this$props, arguments);
                    if (_this.timeout) clearTimeout(_this.timeout);

                    // eye on the prize
                    var goal = _this.goal = !_this.goal;
                    var delay = goal ? onDelay : offDelay;

                    var commit = function commit() {
                        _this.timeout = null;
                        _this.setState({ active: goal });
                    };

                    if (delay) {
                        _this.timeout = setTimeout(commit, delay);
                    } else {
                        commit();
                    }
                };

                _this.timeout = null;
                _this.goal = false;
                _this.state = {
                    active: false
                };
                return _this;
            }

            _createClass(WrappedComponent, [{
                key: 'componentWillUnmount',
                value: function componentWillUnmount() {
                    if (this.timeout) clearTimeout(this.timeout);
                }
            }, {
                key: 'render',
                value: function render() {
                    var _extends2;

                    var props = _extends({}, this.props, (_extends2 = {}, _defineProperty(_extends2, key, this.state.active), _defineProperty(_extends2, handler, this.onToggle), _extends2));

                    return (0, _react.createElement)(OriginalComponent, props);
                }
            }]);

            return WrappedComponent;
        }(_react.Component);

        WrappedComponent.displayName = 'ToggleAware(' + (0, _reactDisplayName2.default)(OriginalComponent) + ')';


        return (0, _hoistNonReactStatics2.default)(WrappedComponent, _react.Component);
    };
};